stages: [build, test, release]

default:
  interruptible: true

variables:
  # Performs an error check after each Bash script command is executed, and exits if the previously executed command returned a non-zero exit code
  # https://gitlab.com/gitlab-org/gitlab-runner/-/merge_requests/2671
  FF_ENABLE_BASH_EXIT_CODE_CHECK: "true"
  CHANGELOG_FILE: "changelog.md"

.release-rules:
  rules:
    - if: $CI_COMMIT_TAG =~ /^\d+\.\d+\.\d+$/

generate-changelog:
  extends: .release-rules
  stage: release
  image:
    name: "gitlab/glab"
    entrypoint: [""]
  script:
    - glab changelog generate --version "${CI_COMMIT_TAG}" > "${CHANGELOG_FILE}"
  artifacts:
    paths:
      - "${CHANGELOG_FILE}"

# If the pipeline is for a new tag with a semantic version, and all previous jobs succeed,
# create the release.
create-release:
  extends: .release-rules
  stage: release
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  needs: [generate-changelog]
  script: echo "Creating release $CI_COMMIT_TAG"
  release:
    name: "${CI_COMMIT_TAG}"
    tag_name: "${CI_COMMIT_TAG}"
    description: "${CHANGELOG_FILE}"

include:
  - template: "Workflows/MergeRequest-Pipelines.gitlab-ci.yml"
  - component: "gitlab.com/gitlab-org/components/danger-review/danger-review@$CI_COMMIT_SHA"
    inputs:
      dry_run: true
    rules:
      - if: '$CI_MERGE_REQUEST_IID'
